#импортируем требуемые для анализа библиотеки из предустановленного пакета biopython
import pandas as pd
from Bio import SeqIO, AlignIO
from Bio.Seq import Seq
import warnings
warnings.filterwarnings("ignore")

import os
probs = os.environ['proby']
with open(probs, 'r') as doc:
    string = [line.strip() for line in doc]
del string[0::2]
string.insert(0, "start")
#открываем файл с мутациями и переводим его в вид словаря
with open('mutations.txt', 'r') as document:
    mut = {}
    for line in document:
        line = line.split()
        if not line:  # empty line?
            continue
        mut[line[0]] = line[1:]
muts = list(mut.values())
#открываем выравненную последовательность и вычисляем количество сиквенсов
alignment = AlignIO.read("alignment.fa", "fasta")
num = len([1 for line in open("alignment.fa") if line.startswith(">")])
#открываем референсную последовательность
record = SeqIO.read("reference.fa", "fasta")
s = list(record.seq)
rows = []
#делаем таблицу сиквенса референса и конкретной пробы, обозначаем делеции и вставки
for j in range(1, num):
    spike = 25383-21562
    nCount = "{:.0%}".format(len(string[j])/spike)
    rows_list = []
    for i in range(0, len(alignment[0])):
        if alignment[j][i] != alignment[0][i]: 
            dict1 = {'REF': alignment[0][i], 'POS': i, 'ALT': alignment[j][i]} 
            rows_list.append(dict1)
    df0 = pd.DataFrame(rows_list) 
    df0.ALT = df0.ALT.replace('-', 'del')
    df0.REF = df0.REF.replace('-', 'ins')
    k = 0
    ins = 0
    #Ищем мутации, сдвигая нумерацию позиций, если они найдены
    for ii in range(0, df0.ALT.count()): 
        if df0.ALT.iloc[ii]=="del": k+=1
        if df0.REF.iloc[ii] == "ins": 
            df0.POS.iloc[ii] = df0.POS.iloc[ii] - k+2
            ins+=1
        if (df0.ALT.iloc[ii] != "del"): df0.POS.iloc[ii] = df0.POS.iloc[ii] - ins+1
    #Оставляем делеции для поиска выпавших аминокислот
    dd1 = df0[df0.ALT == 'del']
    #Ищем делеции в Spike белке (позиции в геноме 21563:25384)
    dd2 = dd1[(dd1.POS>=21562) & (dd1.POS<=25383)]
    delt = []
    delt = (dd2.POS-21562)/3
    #delt2 = [int(x) for x in delt]
    #delt = delt[delt % delt2 == 0]
    delt = [int(x) for x in delt]
    delt = list(set(delt))    
    delt = sorted(delt) #позиция выпавшей аминокислоты в геноме
    df0 = df0.drop(df0[df0.ALT == 'del'].index)
    df0 = df0.drop(df0[df0.REF == 'ins'].index)
    df0 = df0.dropna()
    #Открываем "подставной" референс, который будет равен мутировавшему штамму и сравнен с неизмененным референсом
    probe = list(alignment[0].seq)
    for i in range(0, len(df0)): 
        if (df0.POS.iloc[i]-1)<len(probe): probe[df0.POS.iloc[i]-1] = df0.ALT.iloc[i] #подставляем мутации в "референс"
    spike1 = s[21562:25383]
    spike1 = ''.join(spike1) #переводим последовательность Spike гена в строчный вид для настоящего референса
    spike2 = probe[21562:25383]
    spike2 = ''.join(spike2) #переводим последовательность Spike гена в строчный вид для подставного референса
    translation = Seq(spike1).translate()
    delet = []
    #складываем в массив делеции в аминокислотах
    for n in delt: 
        if len(translation) > n: delet.append(str(str(translation[n]) + str(n+1) + 'del'))
        else: continue
    #функция, создающая таблицу транслированных последовательностей пробы и референса, и выводящая замены
    def trans(seq,probe):
        trans1 = Seq(seq).translate()
        trans2 = Seq(probe).translate()
        data_tuples = list(zip(trans1, trans2))
        dff = pd.DataFrame(data_tuples, columns=['Ref','Probe'])
        arr = []
        new_df = dff[dff['Ref'] != dff['Probe']]
        new_df['index'] = new_df.index
        new_df['index'].loc[::]+=1
        new_df = new_df.drop(new_df[new_df.Probe == 'X'].index)
        df = new_df[['Ref','index','Probe']]
        if (df.empty): reps = ''
        else:
            x = df.to_string(header=False, index=False, index_names=False).split('\n')
            reps = [''.join(ele.split()) for ele in x]
            arr.append(reps) 
        return arr
    sp = str(delet) + ', ' + str(trans(spike1,spike2)) #строка с выводом всех делеций и замен в анализируемой пробе
    chars = ["[","]","'"]
    for c in chars: sp = sp.replace(c, "")
    #Создание табличного вида: Проба-Мутации
    dict0 = {'Номер пробы': [1], 'Мутации': [2], '% покрытия Spike-гена' : [3]}
    dd1 = pd.DataFrame(columns = dict0.keys())
    dd2 = pd.DataFrame(columns=mut.keys())
    result = pd.concat([dd1,dd2])
    result['Номер пробы'] = [alignment[j].name]
    result['Мутации'] = [sp]
    result['% покрытия Spike-гена'] = [nCount]
    #Проверка есть ли мутации для каждой разновидности вируса
    for k in range(0, (len(result.columns)-3)):
        my_list = result['Мутации'].loc[0].split(", ")
        same_values = set(my_list) & set(muts[k])
        if len(same_values) == 0: result.iloc[0][k+3]='Нет'
        elif len(same_values) == len(muts[k]): result.iloc[0][k+3]='Да'
        else: result.iloc[0][k+3]=str(len(same_values)) + '/' + str(len(muts[k])) + ' ' + "{:.0%}".format((len(same_values)/len(muts[k])))
    #Записываем все в итоговую таблицу
    rows.append(result)
    table = pd.concat(rows, ignore_index=True)
    table.reset_index(drop=True, inplace=True)
from datetime import datetime
date = datetime.now().strftime('%Y-%m-%d_%H-%-M')
filename = f'Result_{date}.csv'
table.to_csv(filename, index=False)
